
#include <stdio.h>
#include <string.h>
#include "w4ais.h"


/* Add information returned from waisq and waissearch into a binary tree
** so it can be sorted and displayed nicely.
*/

struct entry *addentry(e, score, lines, bytes, filename, title, type, icon,
docnum)
    struct entry *e;
    int score;
    int lines;
    int bytes;
    char *filename;
    char *title;
    char *type;
    char *icon;
    int docnum;
{
    int isbigger = 0;

    if (strstr(filename, "--------"))
        return e;
    if (e == NULL) {
        e = (struct entry *) emalloc(sizeof(struct entry));
        e->score = score;
        e->lines = lines;
        e->bytes = bytes;
        e->docnum = docnum;
        e->filename = (char *) mystrdup(filename);
        e->title = (char *) mystrdup(title);
        e->type = (char *) mystrdup(type);
        e->icon = (char *) mystrdup(icon);
        e->left = e->right = NULL;
    } else {
        if (!strcmp(sorttype, "score"))
            isbigger = (e->score >= score) ? 1 : 0;
        else if (!strcmp(sorttype, "lines"))
            isbigger = (e->lines >= lines) ? 1 : 0;
        else if (!strcmp(sorttype, "bytes") ||
          !strcmp(sorttype, "size"))
            isbigger = (e->bytes >= bytes) ? 1 : 0;
        else if (!strcmp(sorttype, "title"))
            isbigger = (strcmp(e->title, title) < 0) ? 1 : 0;
        else if (!strcmp(sorttype, "type"))
            isbigger = (strcmp(e->type, type) < 0) ? 1 : 0;

        if (isbigger)
            e->left = addentry(e->left, score, lines, bytes,
                filename, title, type, icon, docnum);
        else
            e->right = addentry(e->right, score, lines, bytes,
                filename, title, type, icon, docnum);
    }

    return e;
}
