
#include <stdio.h>
#include <ctype.h>
#include "w4ais.h"


/* Decodes URL-encoded strings.
*/

char *decode(s)
    char *s;
{
    int i, j, ascint;
    char firstnum, secondnum;
    static char newstr[MAXSTRLEN];

    for (i = j = 0; s[i]; i++) {
        if (s[i] == '%') {
            firstnum = s[++i];
            secondnum = s[++i];
            ascint = (getascii(firstnum) * 16) + getascii(secondnum);
            if (ascint == 10 || ascint == 13)
                ascint = 32;
            newstr[j++] = (char) ascint;
            continue;
        } else if (s[i] == '+') {
            newstr[j++] = ' ';
        } else {
            newstr[j++] = s[i];
        }
    }
    newstr[j] = '\0';

    return newstr;
}

/* Returns the right ASCII code for a hex value.
*/

int getascii(hex)
    char hex;
{
    if ((int) hex >= 48 && (int) hex <= 57)
        return (hex - 48);
    else
        return (hex - 65 + 10);
}

/* Encodes strings so they can be put in URLs.
*/

char *encode(s)
    char *s;
{
    int i;
    char hexstr[HEXLEN];
    static char line[MAXSTRLEN];

    for (i = 0; *s; s++)
        if (*s == ' ') {
            line[i++] = '+';
        } else if (isdigit(*s) || isalpha(*s)) {
            line[i++] = *s;
        } else {
            sprintf(hexstr, "%0X", *s);
            line[i++] = '%';
            line[i++] = hexstr[0];
            line[i] = hexstr[1];

            if (line[i] == '\0') {
                line[i] = line[i - 1];
                line[i - 1] = '0';
            }
            i++;
        }
    line[i] = '\0';

    return line;
}
