
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include "w4ais.h"


/* Reads the config file and grabs all the values it can find.
*/

void getdefaults()
{
	int found, skiplen;
	char *c, line[MAXSTRLEN], value[MAXSTRLEN], sourcepath[MAXSTRLEN],
	lineselection[MAXSTRLEN], suffix[MAXSTRLEN], desc[MAXSTRLEN],
	url[MAXSTRLEN], mime[MAXSTRLEN], rule[MAXSTRLEN];
	FILE *fp;

	found = 0;
	strcpy(lineselection, selection);
	if ((fp = fopen(conffile, "r")) == NULL)
		progerr("Couldn't open configuration file.");
	while (fgets(line, MAXSTRLEN, fp) != NULL) {
		if (line[0] == '#' || line[0] == '\n')
			continue;
		if (getconfvalue(line, "pagetitle", value) != NULL)
			strcpy(pagetitle, value);
		else if (getconfvalue(line, "selfurl", value) != NULL)
			strcpy(selfurl, value);
		else if (getconfvalue(line, "maxhits", value) != NULL)
			strcpy(maxhits, value);
		else if (getconfvalue(line, "addrmask", value) != NULL)
			strcpy(addrmask, value);
		else if (getconfvalue(line, "iconurl", value) != NULL)
			strcpy(iconurl, value);
		else if (getconfvalue(line, "sorttype", value) != NULL)
			strcpy(sorttype, value);
		else if (getconfvalue(line, "swishbin", value) != NULL)
			strcpy(swishbin, value);
		else if (getconfvalue(line, "waisqbin", value) != NULL)
			strcpy(waisqbin, value);
		else if (getconfvalue(line, "waissearchbin", value) != NULL)
			strcpy(waissearchbin, value);
		else if (getconfvalue(line, "useicons", value) != NULL)
			strcpy(useicons, value);
		else if (getconfvalue(line, "body", value) != NULL)
			strcpy(body, value);
		else if (getconfvalue(line, "format", value) != NULL)
			strcpy(format, value);
		else if (getconfvalue(line, "promptstring", value) != NULL)
			strcpy(promptstring, value);
		else if (getconfvalue(line, "help", value) != NULL)
			strcpy(help, value);
		else if (getconfvalue(line, "instructions", value) != NULL)
			strcpy(instructions, value);
		else if (getconfvalue(line, "trailer", value) != NULL)
			strcpy(trailer, value);
		else if ((c = (char *) lstrstr(line, "sourcerules")) &&
		found == 1) {
			c += strlen("sourcerules");
			while (1) {
				strcpy(rule, getword(c, &skiplen));
				if (!skiplen || rule[0] == '\0' ||
				rule[0] == '\n')
					break;
				else {
					c += skiplen;
					ruleslist = (struct source *)
					addsource(ruleslist, rule);
				}
			}
		}
		else if (NULL != (c = (char *) lstrstr(line, "typedef"))) {
			c += strlen("typedef");
			strcpy(suffix, getword(c, &skiplen));
			c += skiplen;
			strcpy(desc, getword(c, &skiplen));
			c += skiplen;
			strcpy(url, getword(c, &skiplen));
			c += skiplen;
			strcpy(mime, getword(c, &skiplen));
			suffixlist = (struct suffixentry *)
			addsuffix(suffixlist, suffix, desc, url, mime);
		}
		else if (NULL != (c = (char *) lstrstr(line, "waissource"))) {
			if (no_options)
				continue;
			indexsources++;
			sourcelist = (struct source *)
			addsource(sourcelist, getdesc(line));
			if (found > 0) {
				found++;
				continue;
			}
			if ((lineselection[0] == '\0') ||
			lstrstr(line, lineselection))
				found = use_selection = 1;
			if (iswqsource(line)) {
				strcpy(searchprog, "waisq");
				c += strlen("waissource");
				strcpy(sourcepath, getword(c, &skiplen));
				c += skiplen;
				strcpy(selection, getword(c, &skiplen));

				if (strchr(sourcepath, '/') == NULL) {
					sourcedir[0] = '\0';
					strcpy(source, sourcepath);
				}
				else {
					strcpy(source,
					strrchr(sourcepath, '/') + 1);
					strncpy(sourcedir, sourcepath,
					strlen(sourcepath) - strlen(source));
				}
			}
			else {
				strcpy(searchprog, "waissearch");
				strcpy(sourcedir, "");
				c += strlen("waissource");
				strcpy(host, getword(c, &skiplen));
				c += skiplen;
				strcpy(port, getword(c, &skiplen));
				c += skiplen;
				strcpy(source, getword(c, &skiplen));
				c += skiplen;
				strcpy(selection, getword(c, &skiplen));
			}
		}
		else if (NULL != (c = (char *) lstrstr(line, "swishsource"))) {
			if (no_options)
				continue;
			indexsources++;
			sourcelist = (struct source *)
			addsource(sourcelist, getdesc(line));
			if (found > 0) {
				found++;
				continue;
			}
			if ((lineselection[0] == '\0') ||
			lstrstr(line, lineselection))
				found = use_selection = 1;
			strcpy(searchprog, "swish");
			c += strlen("swishsource");
			strcpy(sourcepath, getword(c, &skiplen));
			c += skiplen;
			strcpy(selection, getword(c, &skiplen));

			if (strchr(sourcepath, '/') == NULL) {
				sourcedir[0] = '\0';
				strcpy(source, sourcepath);
			}
			else {
				strcpy(source,
				strrchr(sourcepath, '/') + 1);
				strncpy(sourcedir, sourcepath,
				strlen(sourcepath) - strlen(source));
			}
		}
	}
	fclose(fp);
}

/* Is a waissource line describing a waisq source or a waissearch source?
*/

int iswqsource(line)
	char *line;
{
	int skiplen;
	char *c, tmpline[MAXSTRLEN];

	c = line;
	c += strlen("waissource");
	strcpy(tmpline, getword(c, &skiplen));
	c += skiplen;
	strcpy(tmpline, getword(c, &skiplen));

	if (isnum(tmpline))
		return 0;
	else
		return 1;
}

/* Is a string a number?
*/

int isnum(line)
	char *line;
{
	int i;

	for (i = 0; line[i]; i++)
		if (!isdigit(line[i]))
			return 0;
	return 1;
}

/* Grabs values from lines with variables. If the line is in quotes,
** spaces are counted as part of the value.
*/

char *getconfvalue(line, var, value)
	char *line;
	char *var;
	char *value;
{
	int i;
	char *c;
	static char tmpvalue[MAXSTRLEN];

	if ((c = (char *) lstrstr(line, var)) != NULL) {
		if (c != line)
			return NULL;
		c += strlen(var);
		while (isspace(*c) || *c == '\"')
			c++;
		if (*c == '\0')
			return NULL;
		for (i = 0; *c != '\0' && *c != '\"' && *c != '\n' &&
		i < MAXSTRLEN; c++)
			tmpvalue[i++] = *c;
		tmpvalue[i] = '\0';
		strcpy(value, tmpvalue);
		return tmpvalue;
	}
	else
		return NULL;
}

/* Grabs a source description (for the pop-up menu) for sources
** specified in the config file.
*/

char *getdesc(line)
	char *line;
{
	int i;
	char *c;
	static char desc[MAXSTRLEN];

	if ((c = (char *) strchr(line, '\"')) == NULL)
		return NO_DESC;
	c++;
	for (i = 0; *c && *c != '\"' && i < MAXSTRLEN; c++)
		desc[i++] = *c;
	desc[i] = '\0';

	return desc;
}
