
#include <stdio.h>
#include <ctype.h>
#include "w4ais.h"


/* lstrstr() is the Boyer-Moore algorithm from Sedgewick. Where else? :)
*/

void initskip(s, len)
	char *s;
	int len;
{
	int i, j;

	for (i = 0; i < MAXSTRLEN; i++)
		skip[i] = len;
	for (j = 0; j <= len - 1; j++)
		skip[lstrindex(s[j])] = len - j - 1;
}

int lstrindex(c)
	char c;
{
	char d;

	d = tolower(c);
	if (d >= 'a' && d <= 'z')
		return (d - 'a' + 1);
	else
		return 0;
}

char *lstrstr(s, t)
	char *s;
	char *t;
{
	int i, j, k, slen, tlen;

	slen = strlen(s);
	tlen = strlen(t);
	initskip(t, tlen);

	for (i = j = tlen - 1; j > 0; i--, j--) {
		while (tolower(s[i]) != tolower(t[j])) {
			k = skip[lstrindex(s[i])];
			i += (tlen - j > k) ? tlen - j : k;
			if (i >= slen)
				return NULL;
			j = tlen - 1;
		}
	}
	return (s + i);
}
