#include <stdio.h>
#include <string.h>
#include "w4ais.h"



#define KEYWORDVAR "$KEYWORDS"

static char newfilename[MAXSTRLEN], tmpfilename[MAXSTRLEN];

void MungeFileName(oldfilename)
    char *oldfilename;
{
    if (ruleslist != NULL) {
        strcpy(newfilename, ruleparse(oldfilename));
        strcpy(tmpfilename, newfilename);
        strcpy(newfilename,
            replace(tmpfilename, KEYWORDVAR, encode(keywords)));
    } else {
        strcpy(newfilename, oldfilename);
    }
}


void PrintFileHref(e)
    struct entry *e;
{
    if (lstrstr(e->filename, ".src")) {
        strcpy(tmpfilename, encode(keywords));
        printf("<a href=\"%s?%s%s&%s%s&%s%s&%s%s&%s%s&%s%s",
            selfurl, DESCTXT, "yes", HOSTTXT, host,
            PORTTXT, port, SOURCETXT, source, SEARCHPROGTXT,
            "waissearch", SELECTTXT, NO_SELECT);
        printf("&%s%d&%s%s\">", DOCNUMTXT, e->docnum,
            KEYWORDSTXT, tmpfilename);
    } else if (e->docnum != -1 && !strstr(newfilename, "://")) {
        strcpy(tmpfilename, encode(keywords));
        printf("<a href=\"%s?%s%s&%s%s&%s%s&%s%s&%s%s&",
            selfurl, DESCTXT, "yes", HOSTTXT, host,
            PORTTXT, port, SOURCETXT, source, SEARCHPROGTXT,
            "waissearch");
        printf("%s%s&%s%d&%s%s\">", SELECTTXT, NO_SELECT,
            DOCNUMTXT, e->docnum, KEYWORDSTXT, tmpfilename);
    } else {
        printf("<a href=\"%s\">", newfilename);
    }
    printf("%s</a>\n", e->title);
}



/* Prints everything in the entry structures and adds extra information
** in the URLs so we know what to do next time.
*/

void printentries(e)
    struct entry *e;
{
    static int number = 0;

    if (e != NULL) {
        printentries(e->right);
        number++;
        printf("<dt> <b>%d:  </b>", number);
        if (use_icons)
            printf("<img src=\"%s\" align=\"bottom\" alt=\"\">\n ", e->icon);

        MungeFileName(e->filename);
        PrintFileHref(e);

        printf("<dd> Score: <b>%d</b>", e->score);
        if (e->lines >= 0)
            printf(", Lines: <b>%d</b>", e->lines);
#if defined(BOGUS)
        if (e->bytes < 0)
            printf("");
        else
#endif /* BOGUS */
        if (e->bytes <= 1000)
            printf(", Size: <b>%d bytes", e->bytes);
        else
            printf(", Size: <b>%d kbytes", e->bytes / 1000);
        printf("</b>");
        printf(", Type: <b>%s</b>\n", e->type);
        printentries(e->left);
    }
}

void printBriefEntries(e)
    struct entry *e;
{
    if (e != NULL) {
        printBriefEntries(e->right);
        printf("<LI>");

        MungeFileName(e->filename);
        PrintFileHref(e);

        printBriefEntries(e->left);
    }
}

void printTableEntries(e)
    struct entry *e;
{
    static int number = 0;

    if (e != NULL) {
        printTableEntries(e->right);
        number++;
        printf("<TR>");
        printf("<TH ALIGN=\"right\" VALIGN=\"top\">%d</TH>", number);
        printf("<TD VALIGN=\"top\">%d</TD>", e->score);
        printf("<TD VALIGN=\"top\">%s</TD>", e->type);
        printf("<TD VALIGN=\"top\">");
        if (e->lines >= 0)
            printf("%d lines", e->lines);
#if defined(BOGUS)
        if (e->bytes < 0)
            printf("???");
        else
#endif /* BOGUS */
        if (e->bytes <= 1024)
            printf("%d bytes", e->bytes);
        else if (e->bytes <= 1048576)
            printf("%d KB", e->bytes / 1024);
        else
            printf("%d MB", e->bytes / 1048576);
        printf("</TD>");
        printf("<TH ALIGN=\"left\" VALIGN=\"top\">");

        MungeFileName(e->filename);
        PrintFileHref(e);

        printf("</TH>");
        printTableEntries(e->left);
    }
}
