
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "w4ais.h"


/* Prints the generic form for searching.
*/

#define HITSLEN 7
static int hits[HITSLEN] = {10, 20, 30, 40, 50, 75, 100};
#define FORMATS 3
static char *formats[FORMATS] = {"brief", "standard", "table"};
#define SORTTYPES 4
static char *sorttypes[SORTTYPES] = {"score", "size", "title", "type"};

void printform()
{
	char line[MAXSTRLEN];
	FILE *fp;
	int i;

	printf("<FORM METHOD=\"post\" ACTION=\"%s\">\n", selfurl);
	printf("<CENTER>\n<TABLE BORDER=0>\n<TR>\n<TD>Search for:</TD>\n<TD COLSPAN=3><INPUT TYPE=\"text\" NAME=\"keywords\" VALUE=\"%s\" SIZE=40></TD>\n</TR>\n\n", keywords);
	printf("<TR>\n<TD>Max Hits:</TD>\n");
	printf("<TD><SELECT NAME=\"maxhits\">");
	for (i = 0; i < HITSLEN; i++) {
		printf("<OPTION");
		if (atoi(maxhits) == hits[i]) {
			printf(" SELECTED");
		}
		printf(">%d", hits[i]);
	}
	printf("</SELECT></TD>\n");

	printf("<TD>Format:</TD>\n");
	printf("<TD><SELECT NAME=\"format\">");
	for (i = 0; i < FORMATS; i++) {
		printf("<OPTION");
		if (!strcmp(format, formats[i])) {
			printf(" SELECTED");
		}
		printf(">%s", formats[i]);
	}
	printf("</SELECT></TD></TR>\n");

	printf("<TR>\n<TD>Sort by:</TD>\n");
	printf("<TD COLSPAN=3><SELECT NAME=\"sorttype\">");
	for (i = 0; i < SORTTYPES; i++) {
		printf("<OPTION");
		if (!strcmp(sorttype, sorttypes[i])) {
			printf(" SELECTED");
		}
		printf(">%s", sorttypes[i]);
	}
	printf("</SELECT></TD>\n</TR>\n");

	printf("<TR>\n<TD><INPUT TYPE=\"submit\" VALUE=\"  Search  \"></TD>\n");
    printf("<TD><INPUT TYPE=\"reset\" VALUE=\"  Reset  \"></TD>\n</TR>\n");
	printf("</TABLE>\n</CENTER>\n");

	if (indexsources > 1) {
		printf("Select an index to search: ");
		printf("<select name=\"selection\">\n");
		while (sourcelist != NULL) {
			printf("<option%s> %s\n", (lstrstr(sourcelist->line,
			selection)) ? " selected" : "", sourcelist->line);
			sourcelist = sourcelist->next;
		}
		printf("</select>\n<p>\n");
	}
	printf("<input type=hidden name=message value=\"%s\">\n",
	"If you can see this, then your browser can't support hidden fields.");
	printf("<input type=hidden name=source value=\"%s\">\n", source);
	printf("<input type=hidden name=sourcedir value=\"%s\">\n", sourcedir);
	printf("<input type=hidden name=host value=\"%s\">\n", host);
	printf("<input type=hidden name=port value=\"%s\">\n", port);
	printf("<input type=hidden name=searchprog value=\"%s\">\n",
		searchprog);
	printf("<input type=hidden name=iconurl value=\"%s\">\n", iconurl);
	printf("<input type=hidden name=useicons value=\"%s\">\n", useicons);
	printf("<input type=hidden name=conffile value=\"%s\">\n", conffile);
	if (no_options)
		printf("<input type=hidden name=selection value=\"%s\">\n",
			NO_SELECT);
	printf("</form>\n");
	if (help[0]) {
		printf("<B><A HREF=\"%s\">Instructions are available.</A></B>\n", help);
	} else if (instructions[0] && (fp = fopen(instructions, "r"))) {
		while (fgets(line, MAXSTRLEN, fp) != NULL)
			printf("%s", line);
		fclose(fp);
	} else {
		printf("This is a searchable index of information.<br>\n");
		printf("<b>Note:</b> <i>This service can only be used from a forms-");
		printf("capable browser.</i>\n<P>\n");
		printf(
"Enter keywords for your search.  You can try both single and\n\
multi-word searches, separating words with <B>``and''</B>, <B>``or''</B>\n\
and/or <B>``not''</B>.  You may use parentheses for grouping.  A\n\
trailing asterisk <B>(``*'')</B> matches all words beginning with\n\
whatever precedes the asterisk.\n\
\n\
\n\
<P>\n\
<STRONG>Examples:</STRONG>\n\
<UL>\n\
<LI> Internet search engine\n\
<LI> Miles and Sharon\n\
<LI> Esther or Josiah\n\
<LI> (wimp or shrimp) and election\n\
</UL>\n\
");
	}
}
