
#include <stdio.h>
#include <unistd.h>
#include "w4ais.h"


void printheader()
{
	char line[MAXSTRLEN];
	FILE *fp;

	printf("Content-type: text/html\n\n");

	if (lstrstr(pagetitle, ".html")) {
		if ((fp = fopen(pagetitle, "r")) != NULL) {
			while (fgets(line, MAXSTRLEN, fp) != NULL)
				printf("%s", line);
			fclose(fp);
		} else {
			printf("<HTML><HEAD><TITLE>%s</TITLE></HEAD>\n",
				WAISTITLE);
		}
		if (body[0] && (fp = fopen(body, "r"))){
			while (fgets(line, MAXSTRLEN, fp) != NULL)
				printf("%s", line);
			fclose(fp);
		} else {
			printf("<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000000\"\n    LINK=\"#ff0000\" ALINK=\"#00ff00\" VLINK=\"#0000cc\">\n<H1 ALIGN=\"center\"><IMG ALT=\"\" ALIGN=left SRC=\"/icons/w4ais.gif\"> %s</H1>\n<BR CLEAR=\"all\">\n<BLOCKQUOTE>\n", WAISTITLE);
		}
	} else {
		printf("<HTML><HEAD><TITLE>%s</TITLE></HEAD>\n", pagetitle);
		if (body[0] && (fp = fopen(body, "r"))) {
			while (fgets(line, MAXSTRLEN, fp) != NULL)
				printf("%s", line);
			fclose(fp);
		} else {
			printf("<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000000\"\n    LINK=\"#ff0000\" ALINK=\"#00ff00\" VLINK=\"#0000cc\">\n<H1 ALIGN=\"center\"><IMG ALT=\"\" ALIGN=left SRC=\"/icons/w4ais.gif\"> %s</H1>\n<BR CLEAR=\"all\">\n<BLOCKQUOTE>\n", pagetitle);
		}
	}
}

/* Prints a link to the documentation.
*/

void printfooter()
{
	char line[MAXSTRLEN];
	FILE *fp;

	printf("<HR>\n");
	printf("<I>This search was performed by <A HREF=\"%s\">w4ais %s</A>.</I>\n",
		DocUrl, VERSION);
	if (trailer[0] && (fp = fopen(trailer, "r"))) {
		while (fgets(line, MAXSTRLEN, fp) != NULL)
			printf("%s", line);
		fclose(fp);
	}
	printf("</BLOCKQUOTE>\n</BODY>\n</HTML>\n");
}

/* The header for the version information page.
*/

void printversion()
{
	printf("Content-type: text/html\n\n");
	printf("<HTML><HEAD><TITLE>%s</TITLE></HEAD>\n", VERSTITLE);
	printf("<BODY BGCOLOR=\"#ffffff\" TEXT=\"#000000\"\n    LINK=\"#ff0000\" ALINK=\"#00ff00\" VLINK=\"#0000cc\">\n<H1 ALIGN=\"center\"><IMG ALT=\"\" ALIGN=left SRC=\"/icons/w4ais.gif\"> %s</H1>\n<BR CLEAR=\"all\">\n<BLOCKQUOTE>\n", VERSTITLE);
	printf("This is W4AIS version %s.\n<BLOCKQUOTE>\n</BODY>\n</HTML>\n", VERSION);
}

/* Whoops, caught a problem!
*/

void progerr(errstring)
	char *errstring;
{
	printf("Content-type: text/html\n\n");
	printf("<title>W4AIS Error</title>\n");
	printf("<h1 ALIGN=\"center\"><IMG ALT=\"\" ALIGN=left SRC=\"/icons/w4ais.gif\"> W4AIS Error</h1><br>\n");
	printf("This program encountered an error:<p>\n");
	printf("<code>%s</code>\n<p>\n", errstring);
	exit(0);
}

/* Address authorization failed...
*/

void printreject()
{
	printheader();
	printf("<hr>\nSorry, your site either does not have the proper ");
	printf("authorization to use this WAIS index or your ");
	printf("address could not be determined.");
}


/* Couldn't find something...
*/

void notfound()
{
        printf("Sorry, I didn't find any documents that matched your ");
        printf("search for \"<b>%s</b>\"!", keywords);
}


/* Error messages for broken pipes, SIGSEGV, and timing out.
*/

void badconnection()
{
	progerr("Can't connect to this WAIS server (it is probably down).");
}

void badsegviol()
{
	progerr("Caught a memory violation (probably a parsing error).");
}

void badtimeout()
{
	char message[MAXSTRLEN];

	sprintf(message,
		"This service timed out (%d seconds) - it may be too busy.",
		TIMEOUT);
	progerr(message);
}
