
#include <stdio.h>
#include <ctype.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include "w4ais.h"


/* Does a file exist?
*/

int isfile(path)
	char *path;
{
	struct stat stbuf;

	if (stat(path, &stbuf))
		return 0;
	return ((stbuf.st_mode & S_IFMT) == S_IFREG) ? 1 : 0;
}

/* Split up multiple address masks and check them.
*/

int isokstring(string, mask)
	char *string;
	char *mask;
{
	int i;
	char *s, *t;

	if (lstrstr(mask, "all"))
		return 1;

	i = 0;
	t = (char *) mystrdup(mask);

	while (1) {
		s = (char *) strtok((i++) ? NULL : t, ",");
		if (s == NULL)
			break;
		if (isinname(string, s)) {
			free(t);
			return 1;
		}
	}
	free(t);

	return 0;
}

/* Does an address mask fit the user's address?
*/

int isinname(string, mask)
	char *string;
	char *mask;
{
	int i, j;
	char firstchar, lastchar, *tempmask;

	if (!strcmp(mask, "*"))
		return 1;

	firstchar = mask[0];
	lastchar = mask[(strlen(mask) - 1)];
	tempmask = (char *) emalloc(strlen(mask));

	for (i = j = 0; mask[i]; i++)
		if (mask[i] != '*')
			tempmask[j++] = mask[i];
	tempmask[j] = '\0';

	if (firstchar == '*') {
		if (lastchar == '*') {
			if ((char *) strstr(string, tempmask)) {
				free(tempmask);
				return 1;
			}
		}
		else {
			if ((char *) strstr(string, tempmask) ==
			string + strlen(string) - strlen(tempmask)) {
				free(tempmask);
				return 1;
			}
		}
	}
	else if (lastchar == '*') {
		if ((char *) strstr(string, tempmask) == string) {
			free(tempmask);
			return 1;
		}
	}
	else {
		if (!strcmp(string, tempmask)) {
			free(tempmask);
			return 1;
		}
	}
	free(tempmask);

	return 0;
}
