#define TIMEOUT 45
#define MAXARGS 100
#define MAXARGLEN 1000
#define MAXSTRLEN 1024
#define MAXTITLELEN 1000
#define HEXLEN 5
#define TITLETOPLINES 12

#if defined(MAIN_MODULE)
#   define DECL
#   define INIT1(S) = S
#   define EXT extern
#   if ! defined(CONFFILE)
#       define CONFFILE "/www/httpd/conf/w4ais.conf"         /* config file */
#   endif /* CONFFILE */
#   if ! defined(DOCURL)
#       define DOCURL "http://www.netads.com/Doc/w4ais.html"   /* latest docs */
#   endif /* DOCURL */
#else /* MAIN_MODULE */
#   define DECL extern
#   define INIT1(S)
#   define EXT
#endif /* MAIN_MODULE */

DECL char *VERSION         INIT1("W4VERSION");
DECL char *WAISTITLE       INIT1("WAIS Gateway");
DECL char *VERSTITLE       INIT1("WAIS Gateway Version Information");
DECL char *DocUrl          INIT1(DOCURL);

DECL char *CONFFILETXT     INIT1("conffile=");
DECL char *DESCTXT         INIT1("getdesc=");
DECL char *DOCNUMTXT       INIT1("docnum=");
DECL char *FORMATTXT       INIT1("format=");
DECL char *HOSTTXT         INIT1("host=");
DECL char *ICONURLTXT      INIT1("iconurl=");
DECL char *ISINDEXTXT      INIT1("isindex=");
DECL char *KEYWORDSTXT     INIT1("keywords=");
DECL char *MAXHITSTXT      INIT1("maxhits=");
DECL char *PORTTXT         INIT1("port=");
DECL char *SEARCHPROGTXT   INIT1("searchprog=");
DECL char *SELECTTXT       INIT1("selection=");
DECL char *SORTTYPETXT     INIT1("sorttype=");
DECL char *SOURCEDIRTXT    INIT1("sourcedir=");
DECL char *SOURCETXT       INIT1("source=");
DECL char *USEICONSTXT     INIT1("useicons=");
DECL char *VERSIONTXT      INIT1("version=");

DECL char *NO_ICON         INIT1("no icon");
DECL char *NO_DESC         INIT1("(No description)");
DECL char *NO_SELECT       INIT1("none");

DECL char query_string[MAXSTRLEN];
DECL char sorttype[MAXSTRLEN];
DECL char swishbin[MAXSTRLEN];
DECL char waisqbin[MAXSTRLEN];
DECL char waissearchbin[MAXSTRLEN];
DECL char selfurl[MAXSTRLEN];
DECL char iconurl[MAXSTRLEN];
DECL char useicons[MAXSTRLEN];
DECL char pagetitle[MAXSTRLEN];
DECL char selection[MAXSTRLEN];
DECL char addrmask[MAXSTRLEN];
DECL char unknown_icon[MAXSTRLEN];
DECL char unknown_type[MAXSTRLEN];
DECL char unknown_mime[MAXSTRLEN];
DECL char srcdesc[MAXSTRLEN];
DECL char source[MAXSTRLEN];
DECL char sourcedir[MAXSTRLEN];
DECL char maxhits[MAXSTRLEN];
DECL char host[MAXSTRLEN];
DECL char port[MAXSTRLEN];
DECL char searchprog[MAXSTRLEN];
DECL char keywords[MAXSTRLEN];
DECL char format[MAXSTRLEN];
DECL char body[MAXSTRLEN];
DECL char promptstring[MAXSTRLEN] INIT1("the keyword(s) ");
DECL char instructions[MAXSTRLEN] INIT1("");
DECL char help[MAXSTRLEN] INIT1("");
DECL char trailer[MAXSTRLEN] INIT1("");
DECL char conffile[MAXSTRLEN] INIT1(CONFFILE);




DECL int use_icons, indexsources, no_options, use_selection, docnum, version;
DECL int skip[MAXSTRLEN];

struct entry {
    int score;
    int lines;
    int bytes;
    int docnum;
    char *filename;
    char *title;
    char *type;
    char *icon;
    struct entry *left;
    struct entry *right;
};

DECL struct entry *entrylist;

struct source {
    char *line;
    struct source *next;
};

DECL struct source *sourcelist, *ruleslist, *desclist, *bodylist;

struct suffixentry {
    char *suffix;
    char *desc;
    char *url;
    char *mime;
    struct suffixentry *next;
};

DECL struct suffixentry *suffixlist;


/*
 *  FUNCTIONS
 */

char *decode(), *encode(), *getconfvalue(), *getdesc(),
    *geticon(), *getkeywords(), *getmime(), *getqfilename(),
    *getrule(), *getsfilename(), *gettitle(), *gettype(),
    *getvalue(), *getword(), *lstrstr(), *mystrdup(),
    *parsetitle(), *replace(), *ruleparse();

int getascii(), getsize(), getnumber(), isfile(), isinname(),
    isnum(), isokstring(), iswqsource(), lstrindex(), numchar();

void badconnection(), badsegviol(), badtimeout(),
    descwaiss(), desc_waissearch(), doswish(),
    dowaiss(), dowaisq(), getdefaults(),
    notfound(), printBriefEntries(), printTableEntries(),
    printentries(), printheader(), printfooter(),
    printform(), printreject(), printversion(),
    progerr(), read_from_swish(), read_from_waissearch(),
    read_from_waisq(), initskip();

void *emalloc();

struct entry *addentry();
struct source *addsource();
struct suffixentry *addsuffix();

